#
#
# 3DE4.script.name:	Export NReal bs_tdeLens parameters file...
#
# 3DE4.script.version:	v1.1
#
# 3DE4.script.gui:	Main Window::3DE4::File::Export
#
# 3DE4.script.comment:	Exports all the project data into a MEL script, before sourcing make sure mtoa is loaded in Maya and bs_tdeLens is installed.
#
#

from vl_sdv import *

            
cam	= tde4.getCurrentCamera()
if cam!=None:
    lens	= tde4.getCameraLens(cam)
    path	= tde4.postFileRequester("Export Nothing Real bs_tdeLens parameters...","*.txt")
    if path!=None:
        if path.find(".txt",len(path)-7)==-1: path += ".txt"
        f	= open(path,"w")
        if not f.closed:
            if lens!=None:
                fback_w		= tde4.getLensFBackWidth(lens)
                fback_h		= tde4.getLensFBackHeight(lens)
                F		= tde4.getCameraFocalLength(cam, 1)
                focus           = tde4.getCameraFocus(cam, 1)
                p_aspect	= tde4.getLensPixelAspect(lens)
                lco_x		= tde4.getLensLensCenterX(lens)
                lco_y		= tde4.getLensLensCenterY(lens)
                
                # Write Common lens Paramameters
                f.write("tde4_filmback_width_cm %.15f\n"%(fback_w))
                f.write("tde4_filmback_height_cm %.15f\n"%(fback_h))
                f.write("tde4_focal_length_cm %.15f\n"%(F))
                f.write("tde4_pixel_aspect %.15f\n"%(p_aspect))
                f.write("tde4_lens_center_offset_x_cm %.15f\n"%(lco_x))
                f.write("tde4_lens_center_offset_y_cm %.15f\n"%(lco_y))
                
                model = tde4.getLensLDModel(lens)
                
                # Write Model Specific Distortion parameters:
                if model == '3DE Classic LD Model':
                    d  = tde4.getLensDistortion(lens,F)
                    sq = tde4.getLensAnamorphSqueeze(lens,F)
                    xC = tde4.getLensCurvatureX(lens,F)
                    yC = tde4.getLensCurvatureY(lens,F)
                    q  = tde4.getLensQuarticDistortion(lens,F)
                    f.write("Distortion %.15f\n"%(d))
                    f.write("'Anamorphic Squeeze' %.15f\n"%(sq))
                    f.write("'Curvature X' %.15f\n"%(xC))
                    f.write("'Curvature Y' %.15f\n"%(yC))
                    f.write("'Quartic Distortion' %.15f\n"%(q))
            
                if model == '3DE4 Radial - Standard, Degree 4':
                    dd2 = tde4.getLensLDAdjustableParameter(lens, "Distortion - Degree 2", F, focus)
                    ud2 = tde4.getLensLDAdjustableParameter(lens, "U - Degree 2", F, focus)
                    vd2 = tde4.getLensLDAdjustableParameter(lens, "V - Degree 2", F, focus)
                    qd4 = tde4.getLensLDAdjustableParameter(lens, "Quartic Distortion - Degree 4", F, focus)
                    ud4 = tde4.getLensLDAdjustableParameter(lens, "U - Degree 4", F, focus)
                    vd4 = tde4.getLensLDAdjustableParameter(lens, "V - Degree 4", F, focus)
                    phi = tde4.getLensLDAdjustableParameter(lens, "Phi - Cylindric Direction", F, focus)
		    B = tde4.getLensLDAdjustableParameter(lens, "B - Cylindric Bending", F, focus)
                    f.write("'Distortion - Degree 2' %.15f\n"%(dd2))
                    f.write("'U - Degree 2' %.15f\n"%(ud2))
                    f.write("'V - Degree 2' %.15f\n"%(vd2))
                    f.write("'Quartic Distortion - Degree 4' %.15f\n"%(qd4))
                    f.write("'U - Degree 4' %.15f\n"%(ud4))
                    f.write("'V - Degree 4' %.15f\n"%(vd4))
                    f.write("'Phi - Cylindric Direction' %.15f\n"%(phi))
                    f.write("'B - Cylindric Bending' %.15f\n"%(B))
                    
                if model == '3DE4 Anamorphic - Standard, Degree 4':
                    cx02d2 = tde4.getLensLDAdjustableParameter(lens, "Cx02 - Degree 2", F, focus)
                    cy02d2 = tde4.getLensLDAdjustableParameter(lens, "Cy02 - Degree 2", F, focus)
                    cx22d2 = tde4.getLensLDAdjustableParameter(lens, "Cx22 - Degree 2", F, focus)
                    cy22d2 = tde4.getLensLDAdjustableParameter(lens, "Cy22 - Degree 2", F, focus)
                    cx04d4 = tde4.getLensLDAdjustableParameter(lens, "Cx04 - Degree 4", F, focus)
                    cy04d4 = tde4.getLensLDAdjustableParameter(lens, "Cy04 - Degree 4", F, focus)
                    cx24d4 = tde4.getLensLDAdjustableParameter(lens, "Cx24 - Degree 4", F, focus)
                    cy24d4 = tde4.getLensLDAdjustableParameter(lens, "Cy24 - Degree 4", F, focus)
                    cx44d4 = tde4.getLensLDAdjustableParameter(lens, "Cx44 - Degree 4", F, focus)
                    cy44d4 = tde4.getLensLDAdjustableParameter(lens, "Cy44 - Degree 4", F, focus)
                    lensRot = tde4.getLensLDAdjustableParameter(lens, "Lens Rotation", F, focus)
                    sqX = tde4.getLensLDAdjustableParameter(lens, "Squeeze-X", F, focus)
                    sqY = tde4.getLensLDAdjustableParameter(lens, "Squeeze-Y", F, focus)
                    f.write("'Cx02 - Degree 2' %.15f\n"%(cx02d2))
                    f.write("'Cy02 - Degree 2' %.15f\n"%(cy02d2))
                    f.write("'Cx22 - Degree 2' %.15f\n"%(cx22d2))
                    f.write("'Cy22 - Degree 2' %.15f\n"%(cy22d2))
                    f.write("'Cx04 - Degree 4' %.15f\n"%(cx04d4))
                    f.write("'Cy04 - Degree 4' %.15f\n"%(cy04d4))
                    f.write("'Cx24 - Degree 4' %.15f\n"%(cx24d4))
                    f.write("'Cy24 - Degree 4' %.15f\n"%(cy24d4))
                    f.write("'Cx44 - Degree 4' %.15f\n"%(cx44d4))
                    f.write("'Cy44 - Degree 4' %.15f\n"%(cy44d4))
                    f.write("'Lens Rotation' %.15f\n"%(lensRot))
                    f.write("'Squeeze-X' %.15f\n"%(sqX))
                    f.write("'Squeeze-Y' %.15f\n"%(sqY))
                    
                if model == '3DE4 Radial - Fisheye, Degree 8':
                    dd2 = tde4.getLensLDAdjustableParameter(lens, "Distortion - Degree 2", F, focus)
                    qd4 = tde4.getLensLDAdjustableParameter(lens, "Quartic Distortion - Degree 4", F, focus)
                    d6 = tde4.getLensLDAdjustableParameter(lens, "Degree 6", F, focus)
                    d8 = tde4.getLensLDAdjustableParameter(lens, "Degree 8", F, focus)
                    f.write("'Distortion - Degree 2' %.15f\n"%(dd2))
                    f.write("'Quartic Distortion - Degree 4' %.15f\n"%(qd4))
                    f.write("'Degree 6' %.15f\n"%(d6))
                    f.write("'Degree 8' %.15f\n"%(d8))
                    
                if model == '3DE4 Anamorphic, Degree 6':
                    cx02d2 = tde4.getLensLDAdjustableParameter(lens, "Cx02 - Degree 2", F, focus)
                    cy02d2 = tde4.getLensLDAdjustableParameter(lens, "Cy02 - Degree 2", F, focus)
                    cx22d2 = tde4.getLensLDAdjustableParameter(lens, "Cx22 - Degree 2", F, focus)
                    cy22d2 = tde4.getLensLDAdjustableParameter(lens, "Cy22 - Degree 2", F, focus)
                    cx04d4 = tde4.getLensLDAdjustableParameter(lens, "Cx04 - Degree 4", F, focus)
                    cy04d4 = tde4.getLensLDAdjustableParameter(lens, "Cy04 - Degree 4", F, focus)
                    cx24d4 = tde4.getLensLDAdjustableParameter(lens, "Cx24 - Degree 4", F, focus)
                    cy24d4 = tde4.getLensLDAdjustableParameter(lens, "Cy24 - Degree 4", F, focus)
                    cx44d4 = tde4.getLensLDAdjustableParameter(lens, "Cx44 - Degree 4", F, focus)
                    cy44d4 = tde4.getLensLDAdjustableParameter(lens, "Cy44 - Degree 4", F, focus)
                    cx06d6 = tde4.getLensLDAdjustableParameter(lens, "Cx06 - Degree 6", F, focus)
                    cy06d6 = tde4.getLensLDAdjustableParameter(lens, "Cy06 - Degree 6", F, focus)
                    cx26d6 = tde4.getLensLDAdjustableParameter(lens, "Cx26 - Degree 6", F, focus)
                    cy26d6 = tde4.getLensLDAdjustableParameter(lens, "Cy26 - Degree 6", F, focus)
                    cx46d6 = tde4.getLensLDAdjustableParameter(lens, "Cx46 - Degree 6", F, focus)
                    cy46d6 = tde4.getLensLDAdjustableParameter(lens, "Cy46 - Degree 6", F, focus)
                    cx66d6 = tde4.getLensLDAdjustableParameter(lens, "Cx66 - Degree 6", F, focus)
                    cy66d6 = tde4.getLensLDAdjustableParameter(lens, "Cy66 - Degree 6", F, focus)
                    
                    f.write("'Cx02 - Degree 2' %.15f\n"%(cx02d2))
                    f.write("'Cy02 - Degree 2' %.15f\n"%(cy02d2))
                    f.write("'Cx22 - Degree 2' %.15f\n"%(cx22d2))
                    f.write("'Cy22 - Degree 2' %.15f\n"%(cy22d2))
                    f.write("'Cx04 - Degree 4' %.15f\n"%(cx04d4))
                    f.write("'Cy04 - Degree 4' %.15f\n"%(cy04d4))
                    f.write("'Cx24 - Degree 4' %.15f\n"%(cx24d4))
                    f.write("'Cy24 - Degree 4' %.15f\n"%(cy24d4))
                    f.write("'Cx44 - Degree 4' %.15f\n"%(cx44d4))
                    f.write("'Cy44 - Degree 4' %.15f\n"%(cy44d4))
                    f.write("'Cx06 - Degree 6' %.15f\n"%(cx06d6))
                    f.write("'Cy06 - Degree 6' %.15f\n"%(cy06d6))
                    f.write("'Cx26 - Degree 6' %.15f\n"%(cx26d6))
                    f.write("'Cy26 - Degree 6' %.15f\n"%(cy26d6))
                    f.write("'Cx46 - Degree 6' %.15f\n"%(cx46d6))
                    f.write("'Cy46 - Degree 6' %.15f\n"%(cy46d6))
                    f.write("'Cx66 - Degree 6' %.15f\n"%(cx66d6))
                    f.write("'Cy66 - Degree 6' %.15f\n"%(cy66d6))
